[bat]
BAT_BISECTION_OLD=84292fffc2468125632a21c09533a89426ea212e
BAT_BISECTION_NEW=148842c98a24e508aecb929718818fbf4c2a6ff3
BAT_GIT_DIR=/home/anders/src/kernel/bisecting

[build]
#for p in ${BAT_GIT_DIR}/mypatches-v2/*.patch; do
#  git -C "${BAT_GIT_DIR}" am --3way ${p} || git -C "${BAT_GIT_DIR}" am --skip
#done
#git -C "${BAT_GIT_DIR}" push -f own HEAD:my-test-branch
## I need a NEW_SHA since I apply my own crap...
#NEW_SHA=$(git -C "${BAT_GIT_DIR}" rev-parse HEAD)

# Build kernel using Tuxbuild
tuxbuild build --git-repo https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git \
  --target-arch i386 \
  --toolchain gcc-9 \
  --json-out build.json \
  --kconfig defconfig \
  --kconfig https://builds.tuxbuild.com/1lg4QYBjV1LmhBKQgMqCOF7kYgk/config \
  --git-sha ${BAT_KERNEL_SHA}

#  --git-sha ${NEW_SHA}


build_ret=$?

build_json=build.json

GIT_DESCRIBE="$(jq -r .git_describe "${build_json}")"
DOWNLOAD_URL="$(jq -r .download_url "${build_json}")"
# The URL ends with /, so remove the last one
DOWNLOAD_URL="$(echo "${DOWNLOAD_URL}" | cut -d/ -f1-4)"
KERNEL_NAME=$(curl -sSL ${DOWNLOAD_URL}/metadata.json|jq -r '.results.artifacts.kernel[0]')
MODULES_NAME=$(curl -sSL ${DOWNLOAD_URL}/metadata.json|jq -r '.results.artifacts.modules[0]')

export BAT_LAVA_JOBNAME="linux-mainline-rcutorture-bisect ${BAT_BISECTION_NEW} ${GIT_DESCRIBE}"
export BAT_PUB_KERNEL="${DOWNLOAD_URL}/${KERNEL_NAME}"
export BAT_PUB_MODULES="${DOWNLOAD_URL}/${MODULES_NAME}"
export BAT_PUB_MODULES_COMPRESSION="xz"


# This is the same for all lava jobs
####################################
[test]
# Write out LAVA job
rm -f job.yaml
eval "cat << EOF
$(cat <(bat_get_section lavajob))
" > job.yaml 2> /dev/null

LAVAJOB=$(lavacli jobs submit job.yaml)
LAVA_LOG="log-${BAT_KERNEL_SHA_SHORT}"
lavacli jobs show ${LAVAJOB}
lavacli jobs wait ${LAVAJOB}
lavacli jobs logs ${LAVAJOB} > ${LAVA_LOG}
####################################

[discriminator]
# Look for specific message in the log:
if grep -qa 'rcu_torture_writer' ${LAVA_LOG}; then
  echo " ****************************************************** "
  echo " JOB FAILED!"
  echo " ****************************************************** "
  echo " See ${LAVA_LOG}".
  bat_new
else
  echo " ****************************************************** "
  echo " All fine and dandy."
  echo " ****************************************************** "
  echo " See ${LAVA_LOG}".
  bat_old
fi

[lavajob]
timeouts:
  job:
    minutes: 20
  connection:
    minutes: 2
  actions:
    finalize:
      seconds: 60
context:
  guestfs_interface: virtio
  arch: i386
device_type: qemu
job_name: ${BAT_LAVA_JOBNAME}
priority: 99
visibility: public
metadata:
  maybe-metadata: unknown
actions:
- deploy:
    timeout:
      minutes: 40
    to: tmpfs
    namespace: target
    images:
      kernel:
        url: ${BAT_PUB_KERNEL}
        image_arg: -kernel {kernel} --append "root=/dev/sda  rootwait console=ttyS0,115200"
      rootfs:
        url: https://storage.lkft.org/rootfs/oe-sumo/20201207/intel-core2-32/rpb-console-image-lkft-intel-core2-32-20201207155109-3191.rootfs.ext4.gz
        format: ext4
        compression: gz
        apply-overlay: true
        image_arg: -hda {rootfs} -m 4096 -smp 2 -nographic
        overlays:
          modules:
            url: ${BAT_PUB_MODULES}
            path: /
            format: tar
            compression: ${BAT_PUB_MODULES_COMPRESSION}
    os: oe
- boot:
    namespace: target
    auto_login:
      login_prompt: 'login:'
      username: root
      password_prompt: ''
      password: ''
    prompts:
    - 'root@intel-core2-32:'
    - root@(.*):[/~]#
    timeout:
      minutes: 10
    method: qemu
- test:
    namespace: target
    timeout:
      minutes: 15
    definitions:
    - repository: https://github.com/Linaro/test-definitions.git
      from: git
      path: automated/linux/rcutorture/rcutorture.yaml
      name: rcutorture
